<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="html"/>
  <xsl:template match="/">
    <html>
      <head>
        <title>
          <xsl:value-of select="object/name"/>
        </title>
        <link rel="stylesheet" type="text/css" media="all"
              href="../xsl.css" />      
      </head>
      <body>
        <xsl:for-each select="object">
          <h2>
            Vocabulary: <xsl:value-of select="@name"/>
          </h2> 
        </xsl:for-each>
        <h1>Properties</h1>
        <table>
          <xsl:for-each select="object/property">
            <xsl:sort select="@name"
                      order="ascending" />
            <xsl:variable name="color">
              <xsl:choose>
                <xsl:when test="position() mod 2 = 0">
                  <xsl:text>#ffffff</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>#eeeeee</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <tr style="background-color:{$color}">
              <td colspan="">
                <xsl:value-of select="@name"/>
              </td>
            </tr>
          </xsl:for-each>
        </table>
        <h1>Items</h1>
        <table>
          <tr>
            <th>Key</th>
            <th>MsgId</th>
            <th>Text</th>
          </tr>
          <xsl:for-each select="object/item">
            <xsl:sort select="@name"
                      order="ascending" />
            <xsl:variable name="color">
              <xsl:choose>
                <xsl:when test="position() mod 2 = 0">
                  <xsl:text>#ffffff</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>#eeeeee</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <tr style="background-color:{$color}">
              <td colspan="">
                <xsl:value-of select="@key"/>
              </td>
              <td colspan="">
                <xsl:value-of select="@msgid"/>
              </td>
              <td colspan="">
                <xsl:value-of select="text()"/>
              </td>
            </tr>
          </xsl:for-each>
        </table>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
